//+------------------------------------------------------------------+
//|                                                      NEWS_EA.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                 http://www.winning-solution.net/ |
//+------------------------------------------------------------------+

extern double TakeProfit = 100;
extern double StopLoss = 40;
extern double Lots = 0.1;
extern double TrailingStop = 10;
extern double Trap = 30;
extern bool ConventionalTrapping = true; 

int start()
  {
   int cnt, ticket, total;

   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }

   double buystop = Close[0]+Trap*Point;
   double sellstop = Close[0]-Trap*Point;
   
   double high4h = iHigh(NULL,PERIOD_H4,0);
   double low4h = iLow(NULL,PERIOD_H4,0);
   double buy_hilo = high4h;
   double sell_hilo = low4h;
   if(high4h - low4h > 60*Point){ // then what?
   
   }
 
 if(ConventionalTrapping){  
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      else{
      // ----------------------------------
      // buy stop and sell stop orders
      // ----------------------------------
         OrderSend(Symbol(),OP_BUYSTOP,Lots,buystop,3,buystop-StopLoss*Point,buystop+TakeProfit*Point,"News Trading --> Buy",16384,0,Green);
         OrderSend(Symbol(),OP_SELLSTOP,Lots,sellstop,3,sellstop+StopLoss*Point,sellstop-TakeProfit*Point,"News Trading --> Sell",16384,0,Red);
         return(0);
      }
  }
 
   // --------------------
   // delete pending order
   // --------------------
   total=OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELLSTOP &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUYSTOP)   // long position is opened
           {
            // Close short order 
            if(Close[0] > buystop){
                 OrderClose(OrderTicket(),OrderLots(),sellstop,3,Violet); // close position
                 return(0); // exit
            }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(buystop-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<buystop-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),buystop-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            if(Close[0] > sellstop){
                 OrderClose(OrderTicket(),OrderLots(),buystop,3,Violet); // close position
                 return(0); // exit
            }

            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-sellstop)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(sellstop+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),sellstop+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }